﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace MyAddin59
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("4A11EA32-E7D8-4D5B-B7E8-1F69B546F9AE"), ProgId("MyAddin59.AddinModule")]
    public partial class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance 
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        OutlookFoldersEventsClass1 events = null;
        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            if (events == null)
            {
                Outlook.MAPIFolder folder = OutlookApp.Session.GetDefaultFolder(Outlook.OlDefaultFolders.olFolderInbox);
                events = new OutlookFoldersEventsClass1(this);
                events.ConnectTo(folder, eventClassReleasesComObject: true);
                MessageBox.Show(folder.FullFolderPath);
            }
        }

        private void adxOutlookAppEvents1_Quit(object sender, EventArgs e)
        {
            if (events != null) events.RemoveConnection();
        }
    }
}

